import { defineComponent, reactive } from 'vue';
import styles from './index.module.less';
import Pagination from '@/components/pagination';
import { NTabPane, NTabs } from 'naive-ui';
import CardType from '/src/components/card-type';
import SearchGroupResources from './search-group-resources';
import listData from '../xiaoku-music/data.json';
import CardPreview from '/src/components/card-preview';
export default defineComponent({
  name: 'student-studentList',
  setup() {
    const state = reactive({
      searchWord: '',
      loading: false,
      pagination: {
        page: 1,
        rows: 50,
        pageTotal: 0
      },
      tableList: [] as any,
      show: false,
      item: {}
    });
    const forms = reactive({
      list: [],
      height: '100%' as any
    });
    const formatData = () => {
      const rows = listData.rows || [];
      const tempList: any = [];
      rows.forEach((row: any, i: number) => {
        tempList.push({
          id: row.id,
          type: 'SONG',
          title: row.musicSheetName,
          content: row.id,
          url: row.fixedTone ? row.fixedTone.split(',')[0] : '',
          isCollect: i % 3 ? false : true,
          isSelected: i % 4 ? false : true
        });

        if (i === 2 || i === 12) {
          tempList.push({
            id: i + 3,
            type: 'VIDEO',
            title: '其多列',
            content:
              'https://gyt.ks3-cn-beijing.ksyuncs.com/courseware/1687844560120.mp4',
            url: 'https://gyt.ks3-cn-beijing.ksyuncs.com/courseware/1687844640957.png',
            isCollect: i % 3 ? false : true,
            isSelected: i % 4 ? false : true
          });
        }

        if (i === 0 || i === 6) {
          tempList.push({
            id: i + 3,
            type: 'AUDIO',
            title: '歌曲表演 大鹿',
            content:
              'https://cloud-coach.ks3-cn-beijing.ksyuncs.com/1686819360752.mp3',
            url: 'https://gyt.ks3-cn-beijing.ksyuncs.com/courseware/1687916228530.png',
            isCollect: i % 3 ? false : true,
            isSelected: i % 4 ? false : true
          });
        }

        if (i === 5 || i === 15) {
          tempList.push({
            id: i + 3,
            type: 'IMG',
            title: '其多列',
            url: 'https://gyt.ks3-cn-beijing.ksyuncs.com/courseware/1688007481564.jpg',
            isCollect: i % 3 ? false : true,
            isSelected: i % 4 ? false : true
          });
        }
      });

      forms.list = tempList || [];
      // state.pagination.pageTotal = tempList.length;
      state.pagination.rows = tempList.length;
    };
    const getList = () => {
      console.log('getList');
    };

    formatData();
    return () => (
      <div class={styles.listWrap}>
        <NTabs
          defaultValue="shareResources"
          paneClass={styles.paneTitle}
          justifyContent="center"
          paneWrapperClass={styles.paneWrapperContainer}>
          <NTabPane name="shareResources" tab="共享资源">
            <SearchGroupResources />

            <div class={styles.list}>
              {forms.list.map((item: any) => (
                <CardType
                  item={item}
                  onClick={(val: any) => {
                    if (val.type === 'IMG') return;

                    state.show = true;
                    state.item = val;
                  }}
                />
              ))}
            </div>

            <Pagination
              v-model:page={state.pagination.page}
              v-model:pageSize={state.pagination.rows}
              v-model:pageTotal={state.pagination.pageTotal}
              onList={getList}
            />
          </NTabPane>
          <NTabPane name="myResources" tab="我的资源">
            <SearchGroupResources />

            <div class={styles.list}>
              {forms.list.map((item: any) => (
                <CardType item={item} />
              ))}
            </div>

            <Pagination
              v-model:page={state.pagination.page}
              v-model:pageSize={state.pagination.rows}
              v-model:pageTotal={state.pagination.pageTotal}
              onList={getList}
            />
          </NTabPane>
          <NTabPane name="myCollect" tab="我的收藏">
            <SearchGroupResources />

            <div class={styles.list}>
              {forms.list.map((item: any) => (
                <CardType item={item} />
              ))}
            </div>

            <Pagination
              v-model:page={state.pagination.page}
              v-model:pageSize={state.pagination.rows}
              v-model:pageTotal={state.pagination.pageTotal}
              onList={getList}
            />
          </NTabPane>
        </NTabs>

        {/* 弹窗查看 */}
        <CardPreview v-model:show={state.show} item={state.item} />
      </div>
    );
  }
});
